// (C) Copyright 2003: Reece H. Dunn 

#ifndef BOOST__IO__DETAIL__FORMAT_TRAITS__IPP
#define BOOST__IO__DETAIL__FORMAT_TRAITS__IPP
   // formatting for characters:

   const char boost::io::detail::format_traits< char >::open_default      = '[';
   const char boost::io::detail::format_traits< char >::close_default     = ']';
   const char boost::io::detail::format_traits< char >::separator_default = ',';

   bool boost::io::detail::format_traits< char >::isok( char ch ) throw()
   {
      return( ch != '\0' );
   }

   // formatting for wide characters:

   const wchar_t boost::io::detail::format_traits< wchar_t >::open_default      = L'[';
   const wchar_t boost::io::detail::format_traits< wchar_t >::close_default     = L']';
   const wchar_t boost::io::detail::format_traits< wchar_t >::separator_default = L',';

   bool boost::io::detail::format_traits< wchar_t >::isok( wchar_t ch ) throw()
   {
      return( ch != 0 );
   }

   // formatting for strings:

   char * boost::io::detail::format_traits< char * >::open_default      = "[";
   char * boost::io::detail::format_traits< char * >::close_default     = "]";
   char * boost::io::detail::format_traits< char * >::separator_default = ",";

   bool boost::io::detail::format_traits< char * >::isok( const char * s ) throw()
   {
      return( s != 0 );
   }

   // formatting for wide strings:

   wchar_t * boost::io::detail::format_traits< wchar_t * >::open_default      = L"[";
   wchar_t * boost::io::detail::format_traits< wchar_t * >::close_default     = L"]";
   wchar_t * boost::io::detail::format_traits< wchar_t * >::separator_default = L",";

   bool boost::io::detail::format_traits< wchar_t * >::isok( const wchar_t * s ) throw()
   {
      return( s != 0 );
   }
#endif
