// (C) Copyright 2003: Reece H. Dunn 

#ifndef BOOST__IO__FORMATLIST_T__IPP
#define BOOST__IO__FORMATLIST_T__IPP
   template< typename ForwardIterator, typename FormatType, typename Outputter >
   ForwardIterator boost::io::formatlist_t< ForwardIterator, FormatType, Outputter >::begin() const throw()
   {
      return( first );
   }
   template< typename ForwardIterator, typename FormatType, typename Outputter >
   ForwardIterator boost::io::formatlist_t< ForwardIterator, FormatType, Outputter >::end() const throw()
   {
      return( last );
   }

   template< typename ForwardIterator, typename FormatType, typename Outputter >
   boost::io::formatlist_t< ForwardIterator, FormatType, Outputter >::formatlist_t
   (
      ForwardIterator f,
      ForwardIterator l
   ) throw():
      first( f ),
      last(  l )
   {
   }
   template< typename ForwardIterator, typename FormatType, typename Outputter >
   boost::io::formatlist_t< ForwardIterator, FormatType, Outputter >::formatlist_t
   (
      ForwardIterator f,
      ForwardIterator l,
      Outputter       out
   ) throw():
      detail::list_output< FormatType, formatlist_t, Outputter >( out ),
      first( f ),
      last(  l )
   {
   }

   template< typename CharT, class TraitsT, typename ForwardIterator, typename FormatType, typename Outputter >
   std::basic_ostream< CharT, TraitsT > & boost::io::operator<<
   (
      std::basic_ostream< CharT, TraitsT > & os,
      const boost::io::formatlist_t< ForwardIterator, FormatType, Outputter > & fl
   )
   {
      return( fl( os, fl.begin(), fl.end()));
   }
#endif
