// (C) Copyright 2003: Reece H. Dunn 

#ifndef BOOST__IO__FORMATTER__IPP
#define BOOST__IO__FORMATTER__IPP
   // format control
   
   template< typename FormatType, class ReferenceType >
   boost::io::formatter_t< FormatType, ReferenceType >::listfmt_type
   boost::io::formatter_t< FormatType, ReferenceType >::openlist() const throw()
   {
      return( fmt_openlist );
   }
   template< typename FormatType, class ReferenceType >
   boost::io::formatter_t< FormatType, ReferenceType >::listfmt_type
   boost::io::formatter_t< FormatType, ReferenceType >::closelist() const throw()
   {
      return( fmt_closelist );
   }
   template< typename FormatType, class ReferenceType >
   boost::io::formatter_t< FormatType, ReferenceType >::listfmt_type
   boost::io::formatter_t< FormatType, ReferenceType >::separator() const throw()
   {
      return( fmt_separator );
   }

   template< typename FormatType, class ReferenceType >
   ReferenceType & boost::io::formatter_t< FormatType, ReferenceType >::format
   (
      listfmt_type ol,
      listfmt_type cl,
      listfmt_type s
   ) throw()
   {
      fmt_openlist  = ol;
      fmt_closelist = cl;
      fmt_separator = s;
      return( *static_cast< ReferenceType * >( this ));
   }
   template< typename FormatType, class ReferenceType >
   ReferenceType & boost::io::formatter_t< FormatType, ReferenceType >::format
   (
      listfmt_type ol,
      listfmt_type cl
   ) throw()
   {
      fmt_openlist  = ol;
      fmt_closelist = cl;
      return( *static_cast< ReferenceType * >( this ));
   }
   template< typename FormatType, class ReferenceType >
   ReferenceType & boost::io::formatter_t< FormatType, ReferenceType >::format
   (
      listfmt_type s
   ) throw()
   {
      fmt_separator = s;
      return( *static_cast< ReferenceType * >( this ));
   }

   // spacing control

   template< typename FormatType, class ReferenceType >
   bool boost::io::formatter_t< FormatType, ReferenceType >::space_before_sep() const throw()
   {
      return( fmt_spaceBeforeSep );
   }
   template< typename FormatType, class ReferenceType >
   bool boost::io::formatter_t< FormatType, ReferenceType >::space_after_sep() const throw()
   {
      return( fmt_spaceAfterSep );
   }
   template< typename FormatType, class ReferenceType >
   bool boost::io::formatter_t< FormatType, ReferenceType >::space_around_list() const throw()
   {
      return( fmt_spaceAroundList );
   }

   template< typename FormatType, class ReferenceType >
   ReferenceType & boost::io::formatter_t< FormatType, ReferenceType >::space
   (
      bool bs,
      bool as,
      bool al
   ) throw()
   {
      fmt_spaceBeforeSep  = bs;
      fmt_spaceAfterSep   = as;
      fmt_spaceAroundList = al;
      return( *static_cast< ReferenceType * >( this ));
   }
   template< typename FormatType, class ReferenceType >
   ReferenceType & boost::io::formatter_t< FormatType, ReferenceType >::space
   (
      bool bs,
      bool as
   ) throw()
   {
      fmt_spaceBeforeSep = bs;
      fmt_spaceAfterSep  = as;
      return( *static_cast< ReferenceType * >( this ));
   }
   template< typename FormatType, class ReferenceType >
   ReferenceType & boost::io::formatter_t< FormatType, ReferenceType >::space
   (
      bool al
   ) throw()
   {
      fmt_spaceAroundList = al;
      return( *static_cast< ReferenceType * >( this ));
   }

   // constructors

   template< typename FormatType, class ReferenceType >
   boost::io::formatter_t< FormatType, ReferenceType >::formatter_t() throw():
      fmt_openlist(  traits_type::open_default      ),
      fmt_closelist( traits_type::close_default     ),
      fmt_separator( traits_type::separator_default ),
      fmt_spaceBeforeSep(  false ),
      fmt_spaceAfterSep(   true  ),
      fmt_spaceAroundList( true  )
   {
   }

   // boost::io::formatter

   template< typename FormatType >
   boost::io::formatter< FormatType >::formatter() throw(): formatter_t< FormatType, formatter >()
   {
   }
#endif
