// (C) Copyright 2003: Reece H. Dunn 

// Test file for boost/io/formatlist.hpp

#include <iostream>  // std::cout
#include <fstream>   // std::ofstream
#include <string>    // std::srting

#include <algorithm> // std::generate
#include <vector>    // std::vector
#include <list>      // std::list
#include <map>       // std::map

#include <boost/io/formatlist.hpp> // boost::io::formatlist

int main()
{
   // 2D array

   int                                 a2D[ 3 ][ 3 ] =
   {
      { 1, 0, 0 },
      { 0, 1, 0 },
      { 0, 0, 1 }
   };

   // 2D container

   std::list< std::list< char > >      tictactoe;

   tictactoe.push_back( std::list< char >());
      tictactoe.back().push_back( 'O' );
      tictactoe.back().push_back( 'X' );
      tictactoe.back().push_back( 'O' );
   tictactoe.push_back( std::list< char >());
      tictactoe.back().push_back( 'X' );
      tictactoe.back().push_back( 'O' );
      tictactoe.back().push_back( 'X' );
   tictactoe.push_back( std::list< char >());
      tictactoe.back().push_back( 'O' );
      tictactoe.back().push_back( 'X' );
      tictactoe.back().push_back( 'O' );

   // formatter configurations

   boost::io::array_output< char >     arrayfmt;
   arrayfmt.format( '(', ')' );

   boost::io::container_output< char > containerfmt;
   containerfmt.format( '|', '|', '|' ).space( true, true );

   // examples

   std::cout << "int[ 3 ][ 3 ] = " << boost::io::formatlistfn( a2D, a2D + 3, arrayfmt( 3 )) << '\n';

   std::cout << "int[ 3 ][ 3 ] = "
             << boost::io::formatlistfn( a2D, a2D + 3, arrayfmt( 3 ))
                .format( '\n', '\0', '\n' ).space( false, false, false )
             << '\n' << '\n';

   std::cout << "int[ 3 ][ 3 ] = "
             << boost::io::formatlistfn( a2D, a2D + 3, arrayfmt( 1, 2 ))
                .format( '\n', '\0', '\n' ).space( false, false, false )
             << '\n' << '\n';

   std::cout << "std::list< std::list< char > > tictactoe = "
             << boost::io::formatlistfn( tictactoe, containerfmt )
                .format( '\n', '\0', '\n' ).space( false, false, false )
             << '\n';

   return( 0 );
}
