// (C) Copyright 2003: Reece H. Dunn 

// Test file for boost/io/formatlist.hpp

#include <iostream>  // std::cout
#include <fstream>   // std::ofstream
#include <string>    // std::srting

#include <algorithm> // std::generate
#include <vector>    // std::vector
#include <list>      // std::list
#include <map>       // std::map

#include <boost/io/formatlist.hpp> // boost::io::formatlist

int main()
{
   // 3D array

   char                                a3D[ 3 ][ 3 ][ 3 ] =
   {
      {
         { 'A', '0', '0' },
         { '0', 'A', '0' },
         { '0', '0', 'A' }
      }, {
         { 'B', '0', '0' },
         { '0', 'B', '0' },
         { '0', '0', 'B' }
      }, {
         { 'C', '0', '0' },
         { '0', 'C', '0' },
         { '0', '0', 'C' }
      },
   };

   // formatter configurations

   boost::io::array_output< char >     arrayfmt;
   arrayfmt.format( '(', ')' );

   boost::io::container_output< char > containerfmt;
   containerfmt.format( '|', '|', '|' ).space( true, true );

   boost::io::array_output< char, boost::io::array_output< char > >
                                       array3Dfmt( arrayfmt( 3 ));
   array3Dfmt.format( '{', '}', '|' ).space( true, true, true );

   // examples

   std::cout << "char[ 3 ][ 3 ][ 3 ] = "
             << boost::io::formatlistfn( a3D, a3D + 3, array3Dfmt( 3 ))
                .format( '\n', '\0', '\n' ).space( false, false, false )
             << '\n' << '\n';

   return( 0 );
}
